;all the stuff that isn't part of pently music engine, but was included in the demo

;pently for asm6, with modifications by Doug Fraker, June 2016

; Copyright 2010-2015 Damian Yerrick
;
; Copying and distribution of this file, with or without
; modification, are permitted in any medium without royalty provided
; the copyright notice and this notice are preserved in all source
; code copies.  This file is offered as-is, without any warranty.

display_todo:
  lda #VBLANK_NMI
  ldx #$00
  ldy #$3F
  sta PPUCTRL
  stx PPUMASK
  sty PPUADDR
  stx PPUADDR
copypal:
  lda main_palette,x
  sta PPUDATA
  inx
  cpx #32
  bcc copypal

  lda #$00
  tay
  ldx #$20
  jsr ppu_clear_nt

  lda #$20
  sta 1
  lda #$62
  sta 0
  lda #<tracknames_txt
  sta 2
  lda #>tracknames_txt
  sta 3
todo_rowloop:
  ldy 1
  sty PPUADDR
  ldy 0
  sty PPUADDR
  ldy #0
todo_charloop:
  lda (2),y
  beq todo_done
  cmp #$0A
  beq is_newline
  sta PPUDATA
  iny
  bne todo_charloop
is_newline:

  sec
  tya
  adc 2
  sta 2
  lda 3
  adc #0
  sta 3
  lda 0
  adc #32
  sta 0
  lda 1
  adc #0
  sta 1
  cmp #$23
  bcc todo_rowloop
  lda 0
  cmp #$E0
  bcc todo_rowloop
todo_done:
  rts

  
  


draw_y_arrow_sprite:

ypos = 0
tilepos = 1
flip = 2
xpos = 3

  stx xpos
  ldx oam_used
  sta OAM+2,x
  tya
  sec
  sbc #4
  sta OAM,x
  lda #$3e ;#'>'
  sta OAM+1,x
  lda xpos
  sta OAM+3,x
  txa
  clc
  adc #4
  sta oam_used
  rts

  
  
  
  




read_pads:

thisRead = 0
firstRead = 2
lastFrameKeys = 4

  ; store the current keypress state to detect key-down later
  lda cur_keys
  sta lastFrameKeys
  lda cur_keys+1
  sta lastFrameKeys+1

  ; Read the joypads twice in case DMC DMA caused a clock glitch.
  jsr read_pads_once
  lda thisRead
  sta firstRead
  lda thisRead+1
  sta firstRead+1
  jsr read_pads_once

  ; For each player, make sure the reads agree, then find newly
  ; pressed keys.
  ldx #1
fixupKeys:

  ; If the player's keys read out the same way both times, update.
  ; Otherwise, keep the last frame's keypresses.
  lda thisRead,x
  cmp firstRead,x
  bne dontUpdateGlitch
  sta cur_keys,x
dontUpdateGlitch:

;removed zapper support
  
  lda lastFrameKeys,x   ; A = keys that were down last frame
  eor #$FF              ; A = keys that were up last frame
  and cur_keys,x        ; A = keys down now and up last frame
  sta new_keys,x
  dex
  bpl fixupKeys
  rts
  
;removed DAS support
  
  

  
read_pads_once:
  lda #$01
  sta thisRead+1
  sta JOY1
  lsr a
  sta JOY1
-
    lda JOY1       ; read player 1's controller
    and #%00000011 ; ignore D2-D7
    cmp #1         ; CLC if A=0, SEC if A>=1
    rol thisRead   ; put one bit in the register
    lda JOY2       ; read player 2's controller the same way
    and #$03
    cmp #1
    rol thisRead+1
    bcc -       ; once $01 has been shifted 8 times, we're done
  rts

  
  




ppu_clear_nt:

  ; Set base PPU address to XX00
  stx PPUADDR
  ldx #$00
  stx PPUADDR

  ; Clear the 960 spaces of the main part of the nametable,
  ; using a 4 times unrolled loop
  ldx #960/4
loop1:
    sta PPUDATA
	sta PPUDATA
	sta PPUDATA
	sta PPUDATA
  dex
  bne loop1

  ; Clear the 64 entries of the attribute table
  ldx #64
loop2:
  sty PPUDATA
  dex
  bne loop2
  rts

  
  



ppu_clear_oam:

  ; First round the address down to a multiple of 4 so that it won't
  ; freeze should the address get corrupted.
  txa
  and #%11111100
  tax
  lda #$FF  ; Any Y value from $EF through $FF will work
-
  sta OAM,x
  inx
  inx
  inx
  inx
  bne -
  rts

  



ppu_screen_on:
  stx PPUSCROLL
  sty PPUSCROLL
  sta PPUCTRL
  lda #BG_ON
  bcc +
  lda #BG_ON|OBJ_ON
+
  sta PPUMASK
  rts






.align 32  ; ensure that branches do not cross a page boundary


getTVSystem:
  ldx #0
  ldy #0
  lda nmis
nmiwait1:
  cmp nmis
  beq nmiwait1
  lda nmis

nmiwait2:
  inx
  bne +
  iny
+
  cmp nmis
  beq nmiwait2
  tya
  sec
  sbc #10
  cmp #3
  bcc notAbove3
  lda #3
notAbove3:
  rts








;bcd8bit: removed, appears not used


  
  



;bcdConvert: removed, appears not used.






mul8:

factor2 = 1
prodlo = 0

  ; Factor 1 is stored in the lower bits of prodlo; the low dbe of
  ; the product is stored in the upper bits.
  lsr a  ; prime the carry bit for the loop
  sta prodlo
  sty factor2
  lda #0
  ldy #8
-
  ; At the start of the loop, one bit of prodlo has already been
  ; shifted out into the carry.
  bcc noadd
  clc
  adc factor2
noadd:
  ror a
  ror prodlo  ; pull another bit out for the next iteration
  dey         ; inc/dec don't modify carry; only shifts and adds do
  bne -
  rts





getCurBeatFraction:

  ldx tvSystem
  beq isNTSC_1
  ldx #1
isNTSC_1:

  ; as an optimization in the music engine, tempoCounter is
  ; actually stored as a negative number: -3606 through -1
  clc
  lda pently_tempoCounterLo
  adc fpmLo2,x
  sta 0
  lda pently_tempoCounterHi
  adc fpmHi2,x

  ; at this point, A:0 = tempoCounter + fpm (which I'll
  ; call ptc for positive tempo counter)
  ; Divide by 16 by shifting bits 4-11 up into A

    asl 0
    rol a			
	asl 0			
    rol a				
	asl 0
    rol a
	asl 0
    rol a

  
  ldy reciprocal_fpm,x
  ; A = ptc / 16, Y = 65536*6/fpm
  jsr mul8

  ; A:0 = ptc * 4096*6 / fpm, in other words, A = ptc * 96 / fpm
  sta 0
  
  ; now shift rpb to the right in case it's a power of 2
  lda #32
  sta 3
  lda pently_rows_per_beat
rpbloop:
  lsr a
  bcs rpbdone
  lsr 3
  lsr 0
  bpl rpbloop
rpbdone:

  ; The supported values of rpb are 1<<n (simple meter) and
  ; 3<<n (compound meter).  Handle 1<<n quickly.
  bne rpb_not_one
  lda 3
  asl a
  adc 3
  sta 3
  lda 0
  bcc add_whole_rows
rpb_not_one:

  ; Otherwise, rpb is 3<<n, which is slightly slower because we
  ; have to divide by 3 by multiplying by 85/256.
  lda 0
  ldy #$55
  jsr mul8

add_whole_rows:
  ldy pently_row_beat_part
  beq no_add_simple
  clc
loop_add_simple:
  adc 3
  dey
  bne loop_add_simple
no_add_simple:  
  rts





fpmLo2: 
	.db <3606, <3000
fpmHi2: 
	.db >3606, >3000
reciprocal_fpm: 
	.db 109, 131

	
	
	