;pently for asm6, with modifications by Doug Fraker, June 2016

; Copyright 2010-2015 Damian Yerrick
;
; Copying and distribution of this file, with or without
; modification, are permitted in any medium without royalty provided
; the copyright notice and this notice are preserved in all source
; code copies.  This file is offered as-is, without any warranty.




sfx_datalo = pently_zp_state + 0
sfx_datahi = pently_zp_state + 1
sfx_rate = pentlyBSS + 0
sfx_ratecd = pentlyBSS + 1
ch_lastfreqhi = pentlyBSS + 2
sfx_remainlen = pentlyBSS + 3





pently_init:

  lda #$0F
  sta SNDCHN
  lda #$30
  sta $4000
  sta $4004
  sta $400C
  sta ch_lastfreqhi+0
  sta ch_lastfreqhi+8
  sta ch_lastfreqhi+4
  lda #$80
  sta $4008
  lda #8
  sta $4001
  sta $4005
  lda #0
  sta $4003
  sta $4007
  sta $400F
  sta sfx_remainlen+0
  sta sfx_remainlen+4
  sta sfx_remainlen+8
  sta sfx_remainlen+12
  sta sfx_ratecd+0
  sta sfx_ratecd+4
  sta sfx_ratecd+8
  sta sfx_ratecd+12
  sta pently_music_playing
  lda #64
  sta $4011
  rts

  
  



pently_start_sound:

snddatalo = 0
snddatahi = 1
sndchno = 2
sndlen = 3
sndrate = 4

  asl a
  asl a
  tax
  lda pently_sfx_table,x
  sta snddatalo
  lda pently_sfx_table+1,x
  sta snddatahi
  lda pently_sfx_table+2,x
  and #$0C
  sta sndchno
  lda pently_sfx_table+2,x
  lsr a
  lsr a
  lsr a
  lsr a
  sta sndrate
  
  lda pently_sfx_table+3,x
  sta sndlen

;  ; split up square wave sounds between $4000 and $4004
 .if ::SQUARE_POOLING
    lda sndchno
    bne not_ch0to4  ; if not ch 0, don't try moving it
      lda sfx_remainlen+4
      cmp sfx_remainlen
      bcs not_ch0to4
      lda #4
      sta sndchno
    not_ch0to4:
  .endif 

  ldx sndchno
  lda sndlen
  cmp sfx_remainlen,x
  bcc ch_full
  lda snddatalo
  sta sfx_datalo,x
  lda snddatahi
  sta sfx_datahi,x
  lda sndlen
  sta sfx_remainlen,x
  lda sndrate
  sta sfx_rate,x
  lda #0
  sta sfx_ratecd,x
ch_full:
  rts



;;
; Updates sound effect channels.
;

pently_update:
  jsr pently_update_music
  ldx #12
-
  jsr pently_update_music_ch
  jsr pently_update_one_ch
  dex
  dex
  dex
  dex
  bpl -
  rts

  
  


pently_update_one_ch:

  ; At this point, the music engine should have left duty and volume
  ; in 2 and pitch in 3.
  lda sfx_remainlen,x
  ora sfx_ratecd,x
  bne ch_not_done
  lda 2
  bne update_channel_hw

  ; Turn off the channel and force a reinit of the length counter.
  cpx #8
  beq not_triangle_kill
    lda #$30
  not_triangle_kill:
  sta $4000,x
  lda #$FF
  sta ch_lastfreqhi,x
  rts
  
  
  
ch_not_done:

  ; playback rate divider
  dec sfx_ratecd,x
  bpl rate_divider_cancel
  lda sfx_rate,x
  sta sfx_ratecd,x

  ; fetch the instruction
  lda sfx_datalo+1,x
  sta 1
  lda sfx_datalo,x
  sta 0
  clc
  adc #2
  sta sfx_datalo,x
  bcc +
  inc sfx_datahi,x
+
  ldy #0
  .if KEEP_MUSIC_IF_LOUDER
    lda 2
    and #$0F
    sta 4
    lda (0),y
    and #$0F
    
    ; At this point: A = sfx volume; 4 = musc volume
    cmp 4
    bcc music_was_louder
  .endif
  lda (0),y
  sta 2
  iny
  lda (0),y
  sta 3
music_was_louder:
  dec sfx_remainlen,x

update_channel_hw:
  lda 2
  ora #$30
  cpx #12
  bne notnoise
  sta $400C
  lda 3
  sta $400E
rate_divider_cancel:
  rts

  
  
  
notnoise:
  sta $4000,x
  ldy 3
.if SOUND_NTSC_ONLY = 0
  lda tvSystem
  lsr a
  bcc +
  iny
+
.endif
  lda periodTableLo,y
  sta $4002,x
  lda periodTableHi,y
  cmp ch_lastfreqhi,x
  beq no_change_to_hi_period
  sta ch_lastfreqhi,x
  sta $4003,x
no_change_to_hi_period:

  rts







  







noteAttackPos = pently_zp_state + 2
musicPatternPos = pently_zp_state + 16

conductorSegno = pently_zp_state + 26
conductorPos = pently_zp_state + 30
attack_remainlen = pentlyBSS + 16
attackPitch = pentlyBSS + 17
noteEnvVol = pentlyBSS + 18
notePitch = pentlyBSS + 19
noteLegato = pentlyBSS + 32
arpPhase = pentlyBSS + 33
arpInterval1 = pentlyBSS + 34
arpInterval2 = pentlyBSS + 35
noteRowsLeft = pentlyBSS + 48
noteInstrument = pentlyBSS + 49
musicPattern = pentlyBSS + 50
patternTranspose = pentlyBSS + 51
graceTime = pentlyBSS + 68
unused69 = pentlyBSS + 69

; Shared state
unused70 = pentlyBSS + 70
attackChannel = pentlyBSS + 71
pently_rows_per_beat = pentlyBSS + 74
pently_row_beat_part = pentlyBSS + 75
pently_tempoCounterLo = pentlyBSS + 78
pently_tempoCounterHi = pentlyBSS + 79
music_tempoLo = pentlyBSS + 82
music_tempoHi = pentlyBSS + 83
conductorWaitRows = pentlyBSS + 86
pently_music_playing = pentlyBSS + 87

FRAMES_PER_MINUTE_PAL = 3000
FRAMES_PER_MINUTE_NTSC = 3606




fpmLo:
  .db <FRAMES_PER_MINUTE_NTSC, <FRAMES_PER_MINUTE_PAL
fpmHi:
  .db >FRAMES_PER_MINUTE_NTSC, >FRAMES_PER_MINUTE_PAL
invfpm:
  .db 8192*48/FRAMES_PER_MINUTE_NTSC, 8192*48/FRAMES_PER_MINUTE_PAL

silentPattern:
  .db 26*8+7, 255
  
durations:
  .db 1, 2, 3, 4, 6, 8, 12, 16
invdurations:
  .db 48/1, 48/2, 48/3, 48/4, 48/6, 48/8, 48/12, 48/16


pently_start_music:

  asl a
  tax
  lda pently_songs,x
  sta conductorPos
  sta conductorSegno
  lda pently_songs+1,x
  sta conductorPos+1
  sta conductorSegno+1

  ldx #16
  bne channelLoopSkipHWOnly
channelLoop:
    lda #0
    sta noteEnvVol,x
    channelLoopSkipHWOnly:
    lda #<silentPattern
    sta musicPatternPos,x
    lda #>silentPattern
    sta musicPatternPos+1,x
    sta musicPattern,x  ; bit 7 set: no pattern playing
    lda #0
    sta arpInterval1,x
    sta noteLegato,x
    sta arpPhase,x
    sta arpInterval2,x
    sta patternTranspose,x
    sta noteInstrument,x
    sta noteRowsLeft,x
    sta attack_remainlen,x
    sta graceTime,x
    dex
    dex
    dex
    dex
    bpl channelLoop
  ; A is still 0
  sta conductorWaitRows
  sta attackChannel
  lda #4
  sta pently_rows_per_beat
  lda #$FF
  sta pently_row_beat_part
  sta pently_tempoCounterLo
  sta pently_tempoCounterHi
  lda #<300
  sta music_tempoLo
  lda #>300
  sta music_tempoHi

  
resume_music:
  lda #1
  sta pently_music_playing
  rts

  

stop_music:
  lda #0
  sta pently_music_playing
  rts

  

pently_update_music:
  lda pently_music_playing
  beq music_not_playing
  lda music_tempoLo
  clc
  adc pently_tempoCounterLo
  sta pently_tempoCounterLo
  lda music_tempoHi
  adc pently_tempoCounterHi
  sta pently_tempoCounterHi
  bcs new_tick
music_not_playing:
  rts
  
  
  
new_tick:

.if SOUND_NTSC_ONLY
  ldy #0
.else
  ldy tvSystem
  beq is_ntsc_1
  ldy #1
is_ntsc_1:
.endif

  ; Subtract tempo
  lda pently_tempoCounterLo
  sbc fpmLo,y
  sta pently_tempoCounterLo
  lda pently_tempoCounterHi
  sbc fpmHi,y
  sta pently_tempoCounterHi
  
  ; Update row
  ldy pently_row_beat_part
  iny
  cpy pently_rows_per_beat
  bcc +
  ldy #0
+
  sty pently_row_beat_part
  lda conductorWaitRows
  beq doConductor
  dec conductorWaitRows
  jmp skipConductor
  

doConductor:

  ldy #0
  lda (conductorPos),y
  inc conductorPos
  bne +
    inc conductorPos+1
+
  sta 0
  cmp #CON_SETTEMPO
  bcc notTempoChange
  cmp #CON_SETBEAT
  bcc isTempoChange
    and #%00000111
    tay
    lda durations,y
    sta pently_rows_per_beat
    ldy #0
    sty pently_row_beat_part
    jmp doConductor
	
	
	
isTempoChange:
    and #%00000111
    sta music_tempoHi
  
    lda (conductorPos),y
    inc conductorPos
    bne +
      inc conductorPos+1
+
    sta music_tempoLo
    jmp doConductor
	
	
	
notTempoChange:
  cmp #CON_WAITROWS
  bcc conductorPlayPattern
  bne notWaitRows
    jmp conductorDoWaitRows
	
	
	
notWaitRows:

  cmp #CON_ATTACK_SQ1
  bcc notAttackSet
  cmp #CON_NOTEON
  bcs handleNoteOn
    and #%00000011
    asl a
    asl a
    sta attackChannel
    jmp doConductor
	
	
	
handleNoteOn:
    and #%00000011
    asl a
    asl a
    tax
    lda (conductorPos),y
    inc conductorPos
    bne +
      inc conductorPos+1
+
    pha
    lda (conductorPos),y
    inc conductorPos
    bne +
      inc conductorPos+1
+
    tay
    pla
    jsr music_play_note
    jmp doConductor

	
	
notAttackSet:

  cmp #CON_FINE
  bne notFine
    lda #0
    sta pently_music_playing
    sta music_tempoHi
    sta music_tempoLo
    rts
	
	

notFine:
  cmp #CON_SEGNO
  bne notSegno
    lda conductorPos
    sta conductorSegno
    lda conductorPos+1
    sta conductorSegno+1
    jmp doConductor
	
	
	
notSegno:
  cmp #CON_DALSEGNO
  bne notDalSegno
    lda conductorSegno
    sta conductorPos
    lda conductorSegno+1
    sta conductorPos+1
    jmp doConductor
	
	
	
notDalSegno:
  
  jmp skipConductor
  
  

conductorPlayPattern:
  and #$07
  asl a
  asl a
  tax
  lda #0
  sta noteLegato,x  ; start all patterns with legato off
  sta noteRowsLeft,x
  lda (conductorPos),y
  sta musicPattern,x
  iny
  lda (conductorPos),y
  sta patternTranspose,x
  iny
  lda (conductorPos),y
  sta noteInstrument,x
  tya
  sec
  adc conductorPos
  sta conductorPos
  bcc +
    inc conductorPos+1
+
  jsr startPattern
  jmp doConductor
  
  

  ; this should be last so it can fall into skipConductor
conductorDoWaitRows:
  lda (conductorPos),y
  inc conductorPos
  bne +
    inc conductorPos+1
+
  sta conductorWaitRows

skipConductor:

  ldx #12
  channelLoop2:
    jsr processTrackPattern
    dex
    dex
    dex
    dex
    bpl channelLoop2
  ldx #16
  ; fall through

processTrackPattern:
  lda noteRowsLeft,x
  beq anotherPatterndbe
skipNote:
  dec noteRowsLeft,x
  rts
  
  
  

anotherPatterndbe:
  lda (musicPatternPos,x)
  cmp #255
  bne notStartPatternOver
    jsr startPattern
    lda (musicPatternPos,x)
  notStartPatternOver:
    
  inc musicPatternPos,x
  bne patternNotNewPage
    inc musicPatternPos+1,x
  patternNotNewPage:

  cmp #INSTRUMENT
  bcc notExtraCommand
  beq isInstrument
    cmp #ARPEGGIO
    bne notArpeggio
    lda (musicPatternPos,x)
    lsr a
    lsr a
    lsr a
    lsr a
    sta arpInterval1,x
    lda (musicPatternPos,x)
    and #$0F
    sta arpInterval2,x
    jmp nextPatterndbe
	
	
	
  notArpeggio:
    cmp #LEGATO_ON+1
    bcs notLegato
    cpx #16
    bcs anotherPatterndbe
      and #$01
      sta noteLegato,x
      bpl anotherPatterndbe
  notLegato:
    cmp #GRACE
    bcc isTranspose
    bne anotherPatterndbe
    lda (musicPatternPos,x)
    sta graceTime,x
    jmp nextPatterndbe
	
	
	
  isTranspose:
    ; clc
    lda patternTranspose,x
    adc (musicPatternPos,x)
    sta patternTranspose,x
    jmp nextPatterndbe
	
	
	
  isInstrument:
    lda (musicPatternPos,x)
    sta noteInstrument,x
  nextPatterndbe:
    inc musicPatternPos,x
    bne anotherPatterndbe
    inc musicPatternPos+1,x
    jmp anotherPatterndbe
	
	
	
  notExtraCommand:
  
  ; set the note's duration
  pha
  and #$07
  tay
  lda durations,y
  sta noteRowsLeft,x
  pla
  lsr a
  lsr a
  lsr a
  cmp #25
  bcc isTransposedNote
  beq notKeyOff
    lda #0
    sta attack_remainlen,x
    cpx #16
    bcs notKeyOff
    sta noteEnvVol,x
  notKeyOff:
  jmp skipNote
  
  

  isTransposedNote:
    cpx #12
    beq isDrumNote
    clc
    adc patternTranspose,x
    ldy noteInstrument,x
    jsr music_play_note
    jmp skipNote
	
	

isDrumNote:
  stx 5
  asl a
  pha
  tax
  lda pently_drums,x
  jsr pently_start_sound
  pla
  tax
  lda pently_drums+1,x
  bmi noSecondDrum
  jsr pently_start_sound
noSecondDrum:
  ldx 5
  jmp skipNote

startPattern:
  lda musicPattern,x
  asl a
  bcc notSilentPattern
    lda #<silentPattern
    sta musicPatternPos,x
    lda #>silentPattern
    sta musicPatternPos+1,x
    rts
	
	
	
notSilentPattern:
  tay
  lda pently_patterns,y
  sta musicPatternPos,x
  lda pently_patterns+1,y
  sta musicPatternPos+1,x
  rts

  

;;
; Plays note A on channel X (0, 4, 8, 12) with instrument Y.
; Trashes 0-1 and preserves X.

music_play_note:

notenum = 0
instrument_id = 1

  sta notenum
  sty instrument_id
  tya
  asl a
  asl a
  adc instrument_id
  tay
  
  ; at this point:
  ; x = channel #
  ; y = offset in instrument table
  cpx #16
  bcs skipSustainPart
    lda notenum
    sta notePitch,x
    lda noteLegato,x
    bne skipAttackPart
    lda #0
    sta arpPhase,x
    lda instrument_id
    sta noteInstrument,x
    lda pently_instruments,y
    asl a
    asl a
    asl a
    asl a
    ora #$0C
    sta noteEnvVol,x
  skipSustainPart:

  lda pently_instruments+4,y
  beq skipAttackPart
    txa
    pha
    cpx #16
    bcc notAttackChannel
      ldx attackChannel
      lda #$80  ; Disable arpeggio until sustain
      sta arpPhase,x
    notAttackChannel:
    lda notenum
    sta attackPitch,x
    lda pently_instruments+4,y
    sta noteAttackPos+1,x
    lda pently_instruments+3,y
    sta noteAttackPos,x
    lda pently_instruments+2,y
    and #$7F
    sta attack_remainlen,x
    pla
    tax
  skipAttackPart:
  rts


pently_update_music_ch:

xsave = 0
ysave = 1
out_volume = 2
out_pitch = 3

  lda pently_music_playing
  beq silenced
  lda graceTime,x
  beq nograce
  dec graceTime,x
  bne nograce
  jsr pently_update_music ;::processTrackPattern
nograce:
  lda attack_remainlen,x
  beq noAttack
  dec attack_remainlen,x
  lda (noteAttackPos,x)
  inc noteAttackPos,x
  bne +
  inc noteAttackPos+1,x
+
  sta out_volume
  lda (noteAttackPos,x)
  inc noteAttackPos,x
  bne +
  inc noteAttackPos+1,x
+
  clc
  adc attackPitch,x
  ldy arpPhase,x
  bmi storePitchNoArpeggio
storePitchWithArpeggio:
  sta out_pitch
  stx xsave
  lda #$7F
  and arpPhase,x
  tay
  beq bumpArpPhase

  ; So we're in a nonzero phase.  Load the interval.
  clc
  adc xsave
  tax
  lda arpInterval1-1,x

  ; If phase 2's interval is 0, cycle through two phases (1, 2)
  ; instead of three (0, 1, 2).
  bne bumpArpPhase
  cpy #2
  bcc bumpArpPhase
  ldy #0
bumpArpPhase:
  iny
  cpy #3
  bcc noArpRestart
  ldy #0
noArpRestart:

  ; At this point, A is the arpeggio interval and Y is the next phase
  clc
  adc out_pitch
  sta out_pitch
  ldx xsave
  tya
  sta arpPhase,x
  rts
  
  

storePitchNoArpeggio:
  sta out_pitch
  rts
  
  
  

noAttack:
  lda noteEnvVol,x
  lsr a
  lsr a
  lsr a
  lsr a
  bne notSilenced
silenced:
  lda #0
  sta out_volume
  rts
  
  
  
  
notSilenced:
  sta out_volume
  lda noteInstrument,x
  asl a
  asl a
  adc noteInstrument,x
  tay  
  lda out_volume
  eor pently_instruments,y
  and #$0F
  eor pently_instruments,y
  sta out_volume
  lda noteEnvVol,x
  sec
  sbc pently_instruments+1,y
  bcc silenced
  sta noteEnvVol,x
  lda notePitch,x
  sty ysave
  jsr storePitchWithArpeggio
  ldy ysave

  ; bit 7 of attribute 2: cut note when half a row remains
  lda pently_instruments+2,y
  bpl notCutNote
  lda noteRowsLeft,x
  bne notCutNote

  clc
  lda pently_tempoCounterLo
  adc #<(FRAMES_PER_MINUTE_NTSC/2)
  lda pently_tempoCounterHi
  adc #>(FRAMES_PER_MINUTE_NTSC/2)
  bcc notCutNote
  
  ; if the next dbe in the pattern is a tie or a legato enable
  lda (musicPatternPos,x)
  cmp #LEGATO_ON
  beq notCutNote
  cmp #LEGATO_OFF
  beq yesCutNote
  and #$F8
  cmp #N_TIE
  beq notCutNote
  lda noteLegato,x
  bne notCutNote
yesCutNote:
  lda #0
  sta noteEnvVol,x

notCutNote:
  rts







;;;;;;;;;;;;;;;;pently seq, included above




CON_PLAYPAT = $00   ; next: pattern, transpose (ignored if drums), instrument (ignored if drums)
CON_WAITROWS = $20  ; next: number of rows to wait minus 1
CON_FINE = $21      ; stop music now
CON_SEGNO = $22     ; set loop point
CON_DALSEGNO = $23  ; jump to loop point. if no point was set, jump to start of song.
CON_ATTACK_SQ1 = $24
CON_ATTACK_SQ2 = $25
CON_ATTACK_TRI = $26
CON_NOTEON = $28
CON_SETTEMPO = $30  ; low bits: bits 10-8 of tempo in rows/min; next: bits 7-0 of tempo
CON_SETBEAT = $38  ; low bits: duration type (D_something) corresponding to one beat

; Sound effect/drum definitions
.macro sfxdef baseaddr, length, period, channel
;.exportzp name
;.assert * - pently_sfx_table < 256, error, "too many sound effects"
;name = <((* - pently_sfx_table) / 4)
  .dw baseaddr
  .db (channel<<2)|((period - 1)<<4)
  .db length
.endm



.macro sfxframe duty, volume, pitch
  .db ((duty)<<6|(volume))
  .db (pitch)
.endm


;.macro drumdef name, sfx1, sfx2
;name = <(* - pently_drums) * 4
;  .db sfx1
;  .ifblank sfx2
;    .db $80
;  .else
;    .db sfx2
;  .endif
;.endm


; Instrument definitions
.macro instdef duty, volume, decayrate, earlycut, attackptr, attacklen
;name = <(* - pently_instruments) / 5
;.local earlycutbits, attacklenbits
  .db (((duty) << 6) | (volume))
  .db decayrate

    .if (earlycut)
      earlycutbits = $80
    .else
      earlycutbits = $00
    .endif

  .if attacklen
    .byte earlycutbits|(attacklen)
    .dw attackptr
  .else
    .byte earlycutbits
    .dw 0
  .endif
.endm




; Song definition
;.macro songdef name, conductor_addr
;name = <(* - pently_songs) / 2
;  .dw (conductor_addr)
;  NUM_SONGS_SO_FAR .set name + 1
;.endm

; Pattern definition
;.macro patdef name, pattern_addr
;name = <(* - pently_patterns) / 2
;  .dw (pattern_addr)
;.endm

; Conductor



; Conductor macros
.macro playPatSq1 patid, transpose, instrument
  .db CON_PLAYPAT|0, patid, transpose, instrument
.endm

.macro playPatSq2 patid, transpose, instrument
  .db CON_PLAYPAT|1, patid, transpose, instrument
.endm

.macro playPatTri patid, transpose, instrument
  .db CON_PLAYPAT|2, patid, transpose, instrument
.endm

.macro playPatNoise patid, transpose, instrument
  .db CON_PLAYPAT|3, patid, 0, 0
.endm

.macro playPatAttack patid, transpose, instrument
  .db CON_PLAYPAT|4, patid, transpose, instrument
.endm

.macro stopPatSq1
  .db CON_PLAYPAT|0, 255, 0, 0
.endm

.macro stopPatSq2
  .db CON_PLAYPAT|1, 255, 0, 0
.endm

.macro stopPatTri
  .db CON_PLAYPAT|2, 255, 0, 0
.endm

.macro stopPatNoise
  .db CON_PLAYPAT|3, 255, 0, 0
.endm

.macro stopPatAttack
  .db CON_PLAYPAT|4, 255, 0, 0
.endm

.macro waitRows n
  .db CON_WAITROWS, (n)-1
.endm

.macro fine
  .db CON_FINE
.endm

.macro segno
  .db CON_SEGNO
.endm

.macro dalSegno
  .db CON_DALSEGNO
.endm

.macro setTempo rowsPerMin

irpm = rowsPerMin
  .db CON_SETTEMPO|>irpm, <irpm
.endm

.macro setBeatDuration durCode
  .db CON_SETBEAT|(durCode)
.endm

.macro attackOnSq1
  .db CON_ATTACK_SQ1
.endm

.macro attackOnSq2
  .db CON_ATTACK_SQ2
.endm

.macro attackOnTri
  .db CON_ATTACK_TRI
.endm

.macro noteOnSq1 notenum, instrument
  .db CON_NOTEON|0, notenum, instrument
.endm

.macro noteOnSq2 notenum, instrument
  .db CON_NOTEON|1, notenum, instrument
.endm

.macro noteOnTri notenum, instrument
  .db CON_NOTEON|2, notenum, instrument
.endm

.macro noteOnNoise notenum, instrument
  .db CON_NOTEON|3, notenum, instrument
.endm


; Pattern commands
N_C  =  0*8
N_CS =  1*8
N_D  =  2*8
N_DS =  3*8
N_E  =  4*8
N_F  =  5*8
N_FS =  6*8
N_G  =  7*8
N_GS =  8*8
N_A  =  9*8
N_AS = 10*8
N_B  = 11*8
N_DB = N_CS
N_EB = N_DS
N_GB = N_FS
N_AB = N_GS
N_BB = N_AS
N_CH  = N_C  + 12*8
N_CSH = N_CS + 12*8
N_DBH = N_DB + 12*8
N_DH  = N_D  + 12*8
N_DSH = N_DS + 12*8
N_EBH = N_EB + 12*8
N_EH  = N_E  + 12*8
N_FH  = N_F  + 12*8
N_FSH = N_FS + 12*8
N_GBH = N_GB + 12*8
N_GH  = N_G  + 12*8
N_GSH = N_GS + 12*8
N_ABH = N_AB + 12*8
N_AH  = N_A  + 12*8
N_ASH = N_AS + 12*8
N_BBH = N_BB + 12*8
N_BH  = N_B  + 12*8
N_CHH = N_CH + 12*8
N_TIE = 25*8
REST  = 26*8
INSTRUMENT = $D8
ARPEGGIO = $D9
LEGATO_OFF = $DA
LEGATO_ON = $DB
TRANSPOSE = $DC
GRACE = $DD
PATEND = $FF

; The default duration is one row (a sixteenth note in the tracker).
; OR the pitch with one of these constants.
D_8  = 1
D_D8 = 2
D_4  = 3
D_D4 = 4
D_2  = 5
D_D2 = 6
D_1  = 7






periodTableLo:
  .db $f1,$7f,$13,$ad,$4d,$f3,$9d,$4c,$00,$b8,$74,$34
  .db $f8,$bf,$89,$56,$26,$f9,$ce,$a6,$80,$5c,$3a,$1a
  .db $fb,$df,$c4,$ab,$93,$7c,$67,$52,$3f,$2d,$1c,$0c
  .db $fd,$ef,$e1,$d5,$c9,$bd,$b3,$a9,$9f,$96,$8e,$86
  .db $7e,$77,$70,$6a,$64,$5e,$59,$54,$4f,$4b,$46,$42
  .db $3f,$3b,$38,$34,$31,$2f,$2c,$29,$27,$25,$23,$21
  .db $1f,$1d,$1b,$1a,$18,$17,$15,$14
periodTableHi:
  .db $07,$07,$07,$06,$06,$05,$05,$05,$05,$04,$04,$04
  .db $03,$03,$03,$03,$03,$02,$02,$02,$02,$02,$02,$02
  .db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01
  .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
  .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
  .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
  .db $00,$00,$00,$00,$00,$00,$00,$00
  